Package: AStream
Type: Package
Title: AStream
Version: 2.0
Date: 2013-12-01
Author: A.Alonso, A.Julia and S.Marsal - Grup de Recerca de Reumatologia (IRHUVH)
Maintainer: <bioinformatics@urr.cat>
Depends: multtest, plotrix
Suggests: faahKO, xcms
Description: Metabolite profiling using identification of isotopes, adducts and fragments.
License: GPL (>=2)
URL: http://www.urr.cat
LazyLoad: no
Packaged: 2014-03-12 11:51:55 UTC; aalonso
Encoding: latin1

isotope.search <-
function(ftlist, mz.tol = 3e-3, min_samples = 5, max_ratio = 0.8, n_std = 5, fplot = TRUE){

cat("ISOTOPE ANALYSIS:\n", sep = "")
cat("\t- M/Z tolerance:\t",mz.tol,"u\n", sep = "")
Iso <- c(13.00335 - 12, 2*(13.00335 - 12))
Lab <- c("13C#1/12C-isotope","13C#2/12C-isotope")
pl  <- c("(a) ","(b) ")
cat("\t- C12-isotope m/z:\t",12,"u\n", sep = "")
cat("\t- C13#1-isotope m/z:\t",12+Iso[1],"u\n", sep = "")
cat("\t- C13#2-isotope m/z:\t",12+Iso[2],"u\n", sep = "")

isotopes <- matrix(0,dim(ftlist$feature.set)[1],2*(length(Iso)+1))
annot_isotopes <- matrix(NA,dim(ftlist$feature.set)[1],2)
for (n in 1:length(Iso)){
	index  <- which( abs(ftlist$feature.set[,6]-Iso[n]) < mz.tol )
	cat("\t- ",Lab[n],":\t",length(index)," feature pair candidates\n",sep="")
	if(length(index)>1){
		C13C12 <- apply(ftlist$data[ftlist$feature.set[index,2],],1,mean)/apply(ftlist$data[ftlist$feature.set[index,1],],1,mean)
	} else {
		if (length(index)==1) C13C12 <- mean(ftlist$data[ftlist$feature.set[index,2],])/mean(ftlist$data[ftlist$feature.set[index,1],])
	}
  excl   <- which(C13C12>=max_ratio)
  incl   <- which(C13C12<max_ratio)
	cat("\t    ",length(incl)," feature pair candidates after excluding pairs with Ir>=",max_ratio,"\n",sep="")
  isotopes[index[incl],1]   <- ftlist$feature.set[index[incl],1]
  isotopes[index[incl],n+1] <- ftlist$feature.set[index[incl],2]
	if (length(index)>1){
		isotopes[index[incl],2+length(Iso)]   <- apply(ftlist$data[ftlist$feature.set[index[incl],1],],1,mean)
		isotopes[index[incl],n+2+length(Iso)] <- apply(ftlist$data[ftlist$feature.set[index[incl],2],],1,mean)
	} else {
		isotopes[index[incl],2+length(Iso)]   <- mean(ftlist$data[ftlist$feature.set[index[incl],1],])
		isotopes[index[incl],n+2+length(Iso)] <- mean(ftlist$data[ftlist$feature.set[index[incl],2],])
	}
	mz1    <- ftlist$mz[ftlist$feature.set[index[incl],1]]
  mz2    <- ftlist$mz[ftlist$feature.set[index[excl],1]]
	if (length(mz1)>(min_samples-1)){
	  cat("\t    LR model fitted\n",sep="")
    model <- lm( as.vector(C13C12[incl]) ~ as.vector(mz1))
    incl2 <- incl
    imz   <- 1:length(incl)
    j <- which(abs(model$residuals)>3*sqrt(var(model$residuals)))
    while(length(j)>0){
      incl2 <- setdiff(incl2,incl2[j])
      imz   <- setdiff(imz,j)
      if (length(incl2)<2) break
      model <- lm( as.vector(C13C12[incl2]) ~ as.vector(mz1[imz]))
      j <- which(abs(model$residuals)>n_std*sqrt(var(model$residuals)))
    }
    cat("\t    ",length(incl2)," feature pair candidates after excluding pairs with high model residuals\n",sep="")
    if (length(incl2)>1){
      annot_isotopes[index[incl2],n]   <- (model$residuals)/sqrt(var(model$residuals))
      annot_isotopes[index[setdiff(incl,incl2)],n]   <- NA
    } 
  } else {
    cat("\t    LR model not fitted\n",sep="")
	}
  if (fplot){
    if (n==1) ge <- split.screen(c(2,1))
    screen(n)
    plot(ftlist$mz[ftlist$feature.set[index,1]],C13C12,cex=1,col="red",xlab="M/Z",ylab="Intensity Ratio",main=paste(pl[n],Lab[n]," ratios (N=",length(incl)," included)",sep=""))
    grid()
    if (length(mz1)>(min_samples-1)){
      x  <- seq(min(mz1),max(mz1),length=100)        
      lines(x,model$coefficients[2]*x+model$coefficients[1],col="black",lwd=2)    
	    if (n==1) lab <- sprintf("I(C13#1)/I(C12) = m/z * %1.2e + %1.2e",model$coefficients[2],model$coefficients[1])
	    if (n==2) lab <- sprintf("I(C13#2)/I(C12) = m/z * %1.2e + %1.2e",model$coefficients[2],model$coefficients[1])
      legend("topright",legend=c("EXCLUDED (r>1)","EXCLUDED (std)","INCLUDED","L.R."),col = c("red","magenta","blue","black"),lty = c(0,0,0,1), cex = .7, pch = c(1,1,1,-1))
    } else {
	    legend("topright",legend=c("EXCLUDED (r>1)","INCLUDED"),col = c(2,4),lty = c(0,0), cex = .7, pch = c(1,1))
	    lab <- ""
    }
    if (lab!="") legend(x=min(mz1),y=max(C13C12)*0.95,legend=lab,bg="aliceblue",pch=-1,cex=0.8)
    points(ftlist$mz[ftlist$feature.set[index,1]],C13C12,cex=1,col="red")
    points(mz1,C13C12[incl],cex=1,col="magenta")
    points(mz1[imz],C13C12[incl2],cex=1,col="blue")
    if (n==length(Iso)) close.screen(all.screens=TRUE)
  }
}
ftlist$isotopes <- isotopes[which(isotopes[,1]>0),]
ftlist$isotopes <- cbind(ftlist$isotopes,annot_isotopes[which(isotopes[,1]>0),])
colnames(ftlist$isotopes)<-c("Index-12C","Index-13C1","Index-13C2","Intensity-12C","Intensity-13C1","Intensity-13C2","Model.Residuals-13C1","Model.Residuals-13C2")
## CHECK FOR REDUNDANT ISOTOPES
i1 <- which(ftlist$isotopes[,2]!=0)
model <- lm( ftlist$isotopes[i1,5]/ftlist$isotopes[i1,4] ~ ftlist$mz[ftlist$isotopes[i1,1]])
U <- unique(ftlist$isotopes[i1,1])
kk1 <- rep(0,length(i1))
for (j in 1:length(U)){
  k <- which(ftlist$isotopes[i1,1]==U[j])
  if (length(k)>1){
    kk1[k[which.min(abs(model$residuals[k]))]]<-1
  } else {
    kk1[k] <- 1
  }
}
i1 <- i1[kk1==1]
i2 <- which(ftlist$isotopes[,3]!=0)
model <- lm( ftlist$isotopes[i2,6]/ftlist$isotopes[i2,4] ~ ftlist$mz[ftlist$isotopes[i2,1]])
U <- unique(ftlist$isotopes[i2,1])
kk1 <- rep(0,length(i2))
for (j in 1:length(U)){
  k <- which(ftlist$isotopes[i2,1]==U[j])
  if (length(k)>1){
    kk1[k[which.min(abs(model$residuals[k]))[1]]]<-1
  } else {
    kk1[k] <- 1
  }
}
i2 <- i2[kk1==1]
ftlist$isotopes <- ftlist$isotopes[sort(c(i1,i2)),]
cat("\t- Total number:\t",dim(ftlist$isotopes)[1]," isotope patterns\n",sep="")
return(ftlist)
}

web.report <-
  function(ftlist, results, datafile, dataset.name = "", output.dir = "web_report"){
    
# FORMAT FOLDER
pathdir <- system.file(package="AStream")
dir.create(output.dir,showWarnings=FALSE)
dir.create(paste(output.dir,"/figures",sep=""),showWarnings=FALSE)
figpath <- paste(output.dir,"/figures/",sep="")
file.copy(paste(pathdir,"html",sep="/"),output.dir,recursive=T)
# LOAD DATA
f    <- file(datafile,"r")
head <- strsplit(readLines(f,1),"\t")[[1]]
r    <- readLines(f,1)
res  <- c()
while(length(r)>0){
  data <- strsplit(r,"\t")[[1]]
  res <- rbind(res,data)
  r    <- readLines(f,1)
}
close(f)
## FORMAT DATA TABLE
for (i in 1:nrow(res)){
  id <- as.numeric(res[i,1])
  res[i,1] <- paste("<td>",res[i,1],"</td>",sep="")
  plott <- 0
  for (j in 2:3){
    temp <- as.character(round(as.numeric(res[i,j]),3))
    res[i,j] <- paste('<td align="left">',temp,'</td>',sep="")
  }
  temp <- as.character(round(as.numeric(res[i,4]),1))
  res[i,4] <- paste('<td align="left">',temp,'</td>',sep="")
  for (j in 5:8){
    res[i,j] <- paste('<td align="left">',res[i,j],"</td>",sep="")
  }
  res[i,9] <- paste('<td align="left"><a href="',res[i,9],'" target="_blank">link</a>','</td>',sep="")
  if (res[i,10]!="0"){
    plott <- 1
    res[i,1] <- gsub("<td>",paste('<td><a href="figures/peak_',id,'.jpg" class="lytebox lytetip" data-tip="" data-title="PEAK NUMER" data-description="" data-lyte-options="showPrint:true tipStyle:classic">',sep=""),res[i,1])
    res[i,1] <- gsub("</td>","</a></td>",res[i,1])
    jpeg(filename=paste(figpath,"peak_",id,".jpg",sep=""),width=800,height=1000)
    g <- plotcompound(id,ftlist,results)
    dev.off()
    res[i,10] <- paste('<td align="left" bgcolor="#00FF00" class=" ">',res[i,10],'</td>',sep="")
  } else{
    res[i,10] <- paste('<td align="left" bgcolor="#FF0000" class=" ">',res[i,10],'</td>',sep="")
  }
  temp <- ""
  for (j in 11:13){
    if (res[i,j]!="NA"){
      if (j==11){
        for (kk in c("id=","rtdiff=","mzdev=","C=")) res[i,j] <- gsub(kk,"",res[i,j])
        temp=paste(temp," [13C1]",res[i,j],sep="")
      }
      if (j==12){
        for (kk in c("id=","rtdiff=","mzdev=","C=")) res[i,j] <- gsub(kk,"",res[i,j])
        temp=paste(temp," [13C2]",res[i,j],sep="")
      }
      if (j==13){
        for (kk in c("id=","rtdiff=","mzdev=","C=")) res[i,j] <- gsub(kk,"",res[i,j])
        temp <- paste(temp," ",res[i,j],sep="")
      }
      
    }
  }
  if (temp==""){
    temp="NA"
    res[i,11]<-paste('<td align="left" bgcolor="#FF0000" class=" ">',temp,"</td>",sep="")
  }else{
    temp <- gsub(" ","<br>",substring(temp,2,nchar(temp)))
    res[i,11]<-paste('<td align="left" bgcolor="#00FF00" class=" ">',temp,"</td>",sep="")
  }
  if (res[i,14]!="0"){
    res[i,14] <- paste('<td align="left" bgcolor="#00FF00" class=" ">',res[i,14],'</td>',sep="")
  } else{
    res[i,14] <- paste('<td align="left" bgcolor="#FF0000" class=" ">',res[i,14],'</td>',sep="")
  }
  if (res[i,15]!=""){
    for (kk in c("id=","rtdiff=","mzdev=","C=")) res[i,15] <- gsub(kk,"",res[i,15])
    res[i,15] <- paste('<td align="left" bgcolor="#00FF00" class=" ">',res[i,15],'</td>',sep="")
  } else{
    res[i,15] <- paste('<td align="left" bgcolor="#FF0000" class=" ">',res[i,15],'</td>',sep="")
  }
  if (res[i,16]!="0"){
    res[i,16] <- paste('<td align="left" bgcolor="#00FF00" class=" ">',res[i,16],'</td>',sep="")
  } else{
    res[i,16] <- paste('<td align="left" bgcolor="#FF0000" class=" ">',res[i,16],'</td>',sep="")
  }
  if (res[i,17]!="NA"){
    temp <- strsplit(res[i,17]," HMDB")[[1]]
    for (k in 1:length(temp)){
      if (k>1){
        temp[k] <- paste("HMDB",temp[k],sep="")
      }
      if (nchar(temp[k])>37){
        temp[k] <- substring(temp[k],1,36)
      }
      j <- strsplit(temp[k],":")[[1]]
      temp[k] <- paste('<a href="http://www.hmdb.ca/metabolites/',j[1],'" target="_blank">',j[1],'</a>:',j[2],sep="")
    }
    temp <- paste(temp,collapse="<br>")
    res[i,17] <- paste('<td align="left" bgcolor="#00FF00" class=" ">',temp,'</td>',sep="")
  } else{
    res[i,17] <- paste('<td align="left" bgcolor="#FF0000" class=" ">',"NA",'</td>',sep="")
  }
  
}

if (file.copy(paste(pathdir,"supp/header.txt",sep="/"),paste(output.dir,"/dataset.html",sep=""))==FALSE){
  file.remove(paste(output.dir,"/dataset.html",sep=""))
  file.copy(paste(pathdir,"supp/header.txt",sep="/"),paste(output.dir,"/dataset.html",sep=""))
}
f    <- file(paste(output.dir,"/dataset.html",sep=""),"a")
cat('<body>',"\n",sep="",file=f)
cat('<div id="header"><img src="./html/css/images/header.png"></div>',"\n",sep="",file=f)
cat('<div id="box1"><div id="content">',"\n",sep="",file=f)
cat("<h2>STUDY NAME: ",dataset.name," / ",strftime(Sys.time(),"%Y-%m-%d %H:%M:%S"),'</h2>',"\n",sep="",file=f)
cat("<center>","\n",sep="",file=f)
cat('<table border="1" class="display dataTable" id="focus_peak_table" style="width:80%">',"\n",sep="",file=f)


header = "<thead><tr>"
for (i in 1+c(0,1,2,3,4,5,6,7,9,10,13,14,15,16)){
  header <- paste(header,'<td>',head[i],'</td>',sep="")
  if (i==4){
    header <- paste(header,'<td bgcolor="#000000"></td>',sep="")
  }
  if (i==8){
    header <- paste(header,'<td bgcolor="#000000"></td>',sep="")
  }
  if (i==11){
    header <- paste(header,'<td bgcolor="#000000"></td>',sep="")
  }
  if (i==15){
    header <- paste(header,'<td bgcolor="#000000"></td>',sep="")
  }
}
header <- paste(gsub("NOTREF.LABELS","NOTREF.LABELS (id/rtD/mzD/C)",gsub("REF.13C#1-isotope","REF.LABELS (id/rtD/mzD/C)",header)),'</tr></thead>',sep="")
cat(header,"\n",sep="",file=f)
cat('<tbody role="alert" aria-live="polite" aria-relevant="all">',"\n",sep="",file=f)
for (i in 1:nrow(res)){
  if ((i%%2)==0){
    n <- '<tr class="even">'
  }else{
    n <- '<tr class="odd">'
  }
  for (j in 1+c(0,1,2,3,4,5,6,7,9,10,13,14,15,16)){
    n <- paste(n,res[i,j],sep="")
    if (j==4){
      n <- paste(n,'<td bgcolor="#000000"></td>',sep="")
    }
    if (j==8){
      n <- paste(n,'<td bgcolor="#000000"></td>',sep="")
    }
    if (j==11){
      n <- paste(n,'<td bgcolor="#000000"></td>',sep="")
    }
    if (j==15){
      n <- paste(n,'<td bgcolor="#000000"></td>',sep="")
    }
  }
  n <- paste(n,'</tr>',sep="")
  cat(n,"\n",sep="",file=f)
}
cat("</tbody></table></center></div></div></body></html>",sep="",file=f)
close(f)
}

astream.annotate <-
function(ftlist, results, range = 1e-2, mode="+", location = c(), nfg_min = 0, output = ""){

cat("FORMATTING AND EXPORTING RESULTS:\n")
cat(" - Positive mode selected\n")
info_ad <- adduct.list(mode)
if (mode=="+") ref <- info_ad$masses[info_ad$labels=="[M+H]"]
if (mode=="-") ref <- info_ad$masses[info_ad$labels=="[M-H]"]
if (!is.factor(ftlist$class$class)) ftlist$class$class <- factor(ftlist$class$class)
cat(" - Computing P-Values for intensity differences between groups\n")
pvals <- compute.count.stats(ftlist)
data(hmdb,package="AStream")
cat(" - HMDB metabolites loaded (n=",nrow(hmdb),")\n",sep="")
if (length(location)>0){
  index <- c()
  for (i in location) index <- c(index,grep(i,hmdb$biofluid,ignore.case=T))
  for (i in location) index <- c(index,grep(i,hmdb$tissue,ignore.case=T))
  index <- sort(unique(index))
  hmdb <- hmdb[index,]
  cat(" - Filtering metabolites by biofluid/tissue location: n=",nrow(hmdb)," after filtering\n")
}
cn    <- c("id","MZ","MassSubmitted","RT","FoldChange","N1","N2","P-value","Metlin","REF.NFG","REF.13C#1-isotope","REF.13C#2-isotope","REF.Adducts","NOTREF.NFG","NOTREF.LABELS")
data  <- matrix(NA,nrow=0,ncol=length(cn))
colnames(data) <- cn
ij  <- setdiff(1:length(ftlist$class$class),ftlist$outliers) #not ouliers
a1 <- which(ftlist$class$class[ij] == levels(ftlist$class$class)[1]) #group 1
a2 <- which(ftlist$class$class[ij] == levels(ftlist$class$class)[2]) #group 2
ftlist$labels <- colnames(results)[6:length(colnames(results))] #adduct labels
nn <- c()
cat(" - Populating results data matrix...\n")
for (i in 1:nrow(ftlist$data)){
  # OTHERS
  Metlin <- paste("http://metlin.scripps.edu/metabo_list.php?mass_min=",
                  round(ftlist$mz[i] - range - ref, 4), "&mass_max=",
                  round(ftlist$mz[i] + range - ref, 4), sep="")
  fc <- round(mean(ftlist$data[i,a1])/mean(ftlist$data[i,a2]),2)
  N1 <- length(which(ftlist$data[i,a1]!=0))
  N2 <- length(which(ftlist$data[i,a2]!=0))
  nfg <- 0
  # [M+H] label (isotopes)
  j   <- which((ftlist$isotopes[,1]==i)&(ftlist$isotopes[,2]>0))
  label13C1 <- "NA"
  label13C2 <- "NA"
  if (length(j)>0){
    if (ftlist$isotopes[j,2]>0){
      nfg <- nfg + 1
      rtdiff <- ftlist$rt[ftlist$isotopes[j,2]]-ftlist$rt[i]
      mzdev  <- abs(abs(ftlist$mz[ftlist$isotopes[j,2]]-ftlist$mz[i])-1.00335)
      k <- which(((ftlist$feature.set[,1]==i)&(ftlist$feature.set[,2]==ftlist$isotopes[j,2]))|((ftlist$feature.set[,2]==i)&(ftlist$feature.set[,1]==ftlist$isotopes[j,2])))
      corr   <- ftlist$feature.set[k,3]
      label13C1 <- sprintf("id=%d;rtdiff=%1.2e;mzdev=%1.2e;C=%1.2f",ftlist$isotopes[j,2],rtdiff,mzdev,corr)
    }  
  }
  j   <- which((ftlist$isotopes[,1]==i)&(ftlist$isotopes[,3]>0))
  if (length(j)>0){
    if (ftlist$isotopes[j,3]>0){
      nfg <- nfg + 1
      rtdiff <- ftlist$rt[ftlist$isotopes[j,3]]-ftlist$rt[i]
      mzdev  <- abs(abs(ftlist$mz[ftlist$isotopes[j,3]]-ftlist$mz[i])-2.00670)
      k <- which(((ftlist$feature.set[,1]==i)&(ftlist$feature.set[,2]==ftlist$isotopes[j,3]))|((ftlist$feature.set[,2]==i)&(ftlist$feature.set[,1]==ftlist$isotopes[j,3])))
      corr   <- ftlist$feature.set[k,3]
      label13C2 <- sprintf("id=%d;rtdiff=%1.1e;mzdev=%1.1e;C=%1.2f",ftlist$isotopes[j,3],rtdiff,mzdev,corr)
    }  
  } 
  # [M+H] label (adducts)
  j   <- which(results[,1]==i)
  if (length(j)>0){
    temp<- results[j,6:ncol(results)]
    if (any(temp>0)){
      k <- which(temp>0)
      for (ik in 1:length(k)){
        nfg    <- nfg + 1
        adduct <- names(temp[k[ik]])
        rtdiff <- ftlist$rt[temp[k[ik]]]-ftlist$rt[i]
        mzdev  <- abs(abs(ftlist$mz[temp[k[ik]]]-ftlist$mz[i]-(info_ad$masses[which(info_ad$labels==adduct)]-ref)))
        kk <- which(((ftlist$feature.set[,1]==i)&(ftlist$feature.set[,2]==temp[k[ik]]))|((ftlist$feature.set[,2]==i)&(ftlist$feature.set[,1]==temp[k[ik]])))
        corr   <- ftlist$feature.set[kk,3]
        if (ik==1) labeladduct <- sprintf("%s:id=%d;rtdiff=%1.1e;mzdev=%1.1e;C=%1.2f",adduct,temp[k[ik]],rtdiff,mzdev,corr)
        if (ik> 1) labeladduct <- sprintf("%s %s:id=%d;rtdiff=%1.1e;mzdev=%1.1e;C=%1.2f",labeladduct,adduct,temp[k[ik]],rtdiff,mzdev,corr)
      }
    } else {
      labeladduct <- "NA"
    }
  } else {
    labeladduct <- "NA"
  }
  t1 <- c(i,round(ftlist$mz[i],5),round(ftlist$mz[i]-ref,5),round(ftlist$rt[i],2),fc,N1,N2,sprintf("%1.2e",pvals[i]),Metlin,nfg,label13C1,label13C2,labeladduct)
  nfg <- 0
  # other labels
  j   <- which(ftlist$isotopes[,2]==i)
  labelothers <- ""
  if (length(j)>0){
    for (k in 1:length(j)){
      nfg <- nfg + 1
      rtdiff <- abs(ftlist$rt[ftlist$isotopes[j[k],1]]-ftlist$rt[i])
      mzdev  <- abs(abs(ftlist$mz[ftlist$isotopes[j[k],1]]-ftlist$mz[i])-1.00335)
      kk <- which(((ftlist$feature.set[,1]==i)&(ftlist$feature.set[,2]==ftlist$isotopes[j[k],1]))|((ftlist$feature.set[,2]==i)&(ftlist$feature.set[,1]==ftlist$isotopes[j[k],1])))
      corr   <- ftlist$feature.set[kk,3]
      labelothers <- sprintf("%s [13C#1]id=%d;rtdiff=%1.2e;mzdev=%1.2e;C=%1.2f",labelothers,ftlist$isotopes[j[k],1],rtdiff,mzdev,corr)
    }
  }
  j   <- which(ftlist$isotopes[,3]==i)
  if (length(j)>0){
    for (k in 1:length(j)){
      nfg <- nfg + 1
      rtdiff <- abs(ftlist$rt[ftlist$isotopes[j[k],1]]-ftlist$rt[i])
      mzdev  <- abs(abs(ftlist$mz[ftlist$isotopes[j[k],1]]-ftlist$mz[i])-1.00335)
      kk <- which(((ftlist$feature.set[,1]==i)&(ftlist$feature.set[,2]==ftlist$isotopes[j[k],1]))|((ftlist$feature.set[,2]==i)&(ftlist$feature.set[,1]==ftlist$isotopes[j[k],1])))
      corr   <- ftlist$feature.set[kk,3]
      labelothers <- sprintf("%s [13C#2]id=%d;rtdiff=%1.2e;mzdev=%1.2e;C=%1.2f",labelothers,ftlist$isotopes[j[k],1],rtdiff,mzdev,corr)
    }
  }
  for (iadduct in 6:ncol(results)){
    j   <- which(results[,iadduct]==i)
    if (length(j)>0){
      temp<- results[j,1]
      for (icand in 1:length(temp)){
        nfg    <- nfg + 1
        adduct <- colnames(results)[iadduct]
        rtdiff <- abs(ftlist$rt[temp[icand]]-ftlist$rt[i])
        mzdev  <- abs(abs(ftlist$mz[i]-ftlist$mz[temp[icand]]-(info_ad$masses[which(info_ad$labels==adduct)]-ref)))
        kk <- which(((ftlist$feature.set[,1]==i)&(ftlist$feature.set[,2]==temp[icand]))|((ftlist$feature.set[,2]==i)&(ftlist$feature.set[,1]==temp[icand])))
        corr   <- ftlist$feature.set[kk,3]
        labelothers <- sprintf("%s %sid=%d;rtdiff=%1.2e;mzdev=%1.2e;C=%1.2f",labelothers,adduct,temp[icand],rtdiff,mzdev,corr)
      }
    }
  }
  t1 <- c(t1,nfg,labelothers)
  nn <- c(nn,length(t1))
  data <- rbind(data,t1)
}
id <- matrix(NA,nrow=nrow(data),ncol=2)
for (i in 1:nrow(data)){
  j       <- which(abs(ftlist$mz[i]  - ref - hmdb[,2]) < range)
  id[i,1] <- length(j)
  if (length(j)>0){
    mzdiff  <- (ftlist$mz[i]  - ref - hmdb[j,2])
    jj <- sort(abs(mzdiff),index.return=T)
    id[i,2] <- paste(hmdb[j[jj$ix],1],rep(":",length(j)),sprintf("%1.1e",jj$x),rep("/",length(j)),hmdb[j[jj$ix],3],collapse=" ",sep="")
  }
}
colnames(id) <- c("HMDB.N","HMDB.MATCHS")
cat(" - Resulting number of features: ",nrow(data),"\n",sep="")
data <- cbind(data,id)
if (nfg_min>0){
  cat(" - Filtering features with less than ",nfg_min," related (isotope/adduct) features\n",sep="")
  data <- data[as.numeric(as.character(data[,10]))>=nfg_min,]
  cat(" - Final number of features: ",nrow(data),"\n",sep="")
}
if (nchar(output)>0){
  cat(" - Exporting results to: ",output,"\n",sep="")
  write.table(data,output,quote=F,sep="\t",row.names=F)
}
return(data)
}

plotcompound <-
function(num, ftlist, results){

index  <- results[,c(1,2,4,6:dim(results)[2])]
label  <- colnames(index)
index  <- index[which(index[,1]==num),]
label  <- label[which(index>0)]
index  <- index[which(index>0)]
cols <- c("black","red","blue","yellow","azure","brown","blueviolet","cyan","magenta","orange","purple")
if (length(label)==0){
  label <- c("C12isotope")
  index <- num
}
ge  <- split.screen(c(ceiling(length(label)/2),2))
int <- c()
for (i in 1:length(label)){
    screen(ge[i])
    par(oma=c(.1,.0,.0,.0))
    par(mar=c(4, 4, 2, 0))
    par(lab=c(4,4,5))
    barplot(ftlist$data[index[i],], names.arg=seq(1,length(ftlist$data[index[i],]),1), xlab="sample index", ylab = "LC/MS intensity", main=paste(label[i],":rt=",round(ftlist$rt[index[i]],1),":m/z=",round(ftlist$mz[index[i]],3),sep=""), col=cols[i],cex.names=.7, cex.axis = .7, cex.main = 1.4)
    grid()
    par(oma=c(3,3,3,3))
    par(lab=c(5,5,7))
    par(mar=c(5,4,4,2)+0.1)
    int <- c(int,mean(ftlist$data[index[i],]))
}
close.screen(all = TRUE)
names(int) <- label
int <- int/int[1]
return(int)
}

adduct.search <-
function(ftlist, mz.tol = 3e-3, adducts = 0, mode = "+", onlyIsotopes = TRUE, fplot = TRUE){

cat("ADDUCT ANALYSIS:\n", sep = "")
if (is.data.frame(adducts)){
    info_ad <- adducts
} else {
    info_ad <- adduct.list(mode)
}

if (length(info_ad$labels)!=length(info_ad$masses)){
    cat("ERROR: Labels and masses lengths are not equal...",sep="")
    return()
}

Nfeat <- dim(ftlist$isotopes)[1]
rmv   <- union(ftlist$isotopes[,2],ftlist$isotopes[,3])
rmv   <- sort(rmv)
rmv<-rmv[2:length(rmv)]

index <- which(ftlist$isotopes[,3]!=0)
for (i in 1:length(index)){
    a <- which(ftlist$isotopes[index[i],1]==ftlist$isotopes[,1])
    if (length(a)>1){
        ftlist$isotopes[index[i],1] <- 0
        ftlist$isotopes[a[1],c(3,6)]<- ftlist$isotopes[a[2],c(3,6)]
    }
} 
ftlist$isotopes <- ftlist$isotopes[which(ftlist$isotopes[,1]!=0),]

corr <- ftlist$feature.set
kk      <- round(length(ftlist$feature.set[,1])/10)
cat("- Creating isotope list: ",sep="")
for (i in 1:length(ftlist$feature.set[,1])){
    if (any(ftlist$feature.set[i,1]==rmv) | any(ftlist$feature.set[i,2]==rmv)) corr[i,1] <- 0
    if (((i-1) %% kk) == 0) cat(10*(i-1)/kk,"% ",sep="")
} 
cat("100%\n",sep="")
corr <- corr[which(ftlist$feature.set[,1]!=0),]

if (onlyIsotopes) g1 <- sort(unique(ftlist$isotopes[,1]))
else g1 <- sort(unique(union(ftlist$feature.set[,1],ftlist$feature.set[,2])))

ftlist$labels <- info_ad$labels
ftlist$masses <- info_ad$masses
mand <- which(ftlist$labels=="[M+H]")
ftlist$masses <- ftlist$masses[setdiff(1:length(ftlist$masses),mand)]-ftlist$masses[mand]
ftlist$labels <- ftlist$labels[setdiff(1:length(ftlist$labels),mand)]

adducts <- matrix(0,length(g1),1+length(ftlist$masses))
k       <- 1
kk      <- round(length(g1)/10)
cat("- Adduct patterns search: ",sep="")
for (i in 1:length(g1)){
    if (((i-1) %% kk) == 0) cat(10*(i-1)/kk,"% ",sep="")
    where <- which(corr[,1]==g1[i] | corr[,2]==g1[i])
    if (length(where)>0){
    if (length(where)==1) data <- matrix(corr[where,c(1,2,6)],1,3)
    else data  <- corr[where,c(1,2,6)]
    z     <- which(data[,1]!=g1[i])
    data[z,3] <- -data[z,3]
    data[z,c(1,2)] <- data[z,c(2,1)]
    ms    <- kronecker( matrix(1,length(data[,1]),1) , matrix(ftlist$masses,1,length(ftlist$masses)))
    ds    <- kronecker( matrix(1,1,length(ftlist$masses)) , matrix(data[,3],length(data[,3]),1))
    ds    <- abs(ds-ms) < mz.tol
    adduct<- which(apply(ds,2,sum)==1)
    if (length(adduct)>0){
        adducts[k,1] <- data[1,1]
        for (j in 1:length(adduct)){
            adducts[k,1+adduct[j]]  <- data[which(ds[,adduct[j]]==1),2]
        } 
        k <- k+1
    }}
} 
cat("\n",sep="")
adducts <- adducts[1:k-1,]
if (length(adducts[1,])>2){
    counts <- apply(adducts[,seq(2,length(adducts[1,]))]!=0,2,sum) 
} else{
    counts <- sum(adducts[,seq(2,length(adducts[1,]))]!=0) 
}

if (fplot) {
  par(las=2)
  par(mar=0.1+c(7,4,3,1))
  barplot(counts, names.arg=ftlist$labels,main="Ion groupping", ylab="#Pairs", cex.names=.7)
  par(mar=0.1+c(5,4,4,2))
  par(las=0)
}
cat("\t- M/Z tolerance:\t+/-",mz.tol,"u\n",sep="")
for (i in 1:length(ftlist$labels)) {
  if (counts[i]>0) cat("\t- ",counts[i]," ",ftlist$labels[i],"adducts.\n", sep = "")
}
ftlist$adducts <- adducts

indexes <- sort(ftlist$isotopes[,1])
final   <- matrix(0,length(indexes),5+length(ftlist$labels))
for (i in 1:length(indexes)){
    final[i,1] <- indexes[i]
    a <- which(ftlist$isotopes[,1]==indexes[i])
    if (length(a)>0) final[i,c(2,3,4,5)]<-c(ftlist$isotopes[a,2],ftlist$isotopes[a,5]/ftlist$isotopes[a,4],ftlist$isotopes[a,3],ftlist$isotopes[a,6]/ftlist$isotopes[a,4])
    a <- which(ftlist$adducts[,1]==indexes[i])
    if (length(a)>0) final[i,seq(6,dim(final)[2])]<-ftlist$adducts[a,seq(2,dim(ftlist$adducts)[2])]
}
colnames(final) <- c("C12isotope","C13#1 isotope","C13#1 ratio","C13#2 isotope","C13#2ratio",ftlist$labels)
return(final)
}

xcms.import <-
function(object){
class    <- object@phenoData
names    <- labels(object@phenoData)[[1]]
values   <- groupval(object,"medret","into")
groupmat <- groups(object)
data     <- cbind(name = groupnames(object), groupmat, values)
data     <- data[,c(2,5,(1+ncol(data)-length(names)):ncol(data))]
data     <-data.frame(data,row.names=1:dim(data)[1])
return(list(data = data, class = class))
}

compute.count.stats <-
function(features){

i       <- setdiff(1:length(features$class$class),features$outliers)
class   <- features$class$class[i]
classes <- levels(class)
if (length(classes)!=2) return(0)
counts  <- features$data

group1  <- which(class==classes[1]) 
group2  <- which(class==classes[2])
m1      <- apply(counts[,group1],1,mean)
m2      <- apply(counts[,group2],1,mean)
tf      <- m2 / m1
tv      <- counts[,c(group1,group2)]
tl      <- c(rep(0,length(group1)),rep(1,length(group2)))
ts      <- mt.teststat(tv,tl)
pvalues <- pvalcc(tv,tl,ts)
return(pvalues)
}

pvalcc <-
function(X, classlabel, teststat) {

    n1 <- rowSums(!is.na(X[,classlabel == 0]))
    n2 <- rowSums(!is.na(X[,classlabel == 1]))
    A <- sd(t(X[,classlabel == 0]), na.rm = TRUE)^2/n1
    B <- sd(t(X[,classlabel == 1]), na.rm = TRUE)^2/n2
    df <- (A+B)^2/(A^2/(n1-1)+B^2/(n2-1))

    pvalue <- 2 * (1 - pt(abs(teststat), df))
    invisible(pvalue)
}

norm.counts <-
function(names, data, mz, rt, std.outliers, zero.missing, min.corr, max.rt, mode = "", mz.tol = 1e-3, adducts = c(), fplot){
###################
## NORMALIZATION ##
###################
cat("NORMALIZATION BY FEATURE MEDIAN...\n",sep="")
data_N     <- data;
j          <- which(apply(data,1,median)!=0)
data_N[j,] <- data_N[j,]/t(kronecker(matrix(1,ncol(data),1), matrix(apply(data_N[j,],1,median),1,length(j)))) 
j          <- which(apply(data,1,median)==0)
if (length(j)>0){
    for (i in 1:length(j)){
        data_N[j[i],] <- data[j[i],] /median(data[j[i],which(data[j[i],]!=0)])
    }
}
####################
## OUTLIER SCORES ##
####################
cat("OUTLIER DETECTION...\n")
breaks     <- c(seq(0,10,by=0.025),max(max(data_N)))
a          <- matrix(0,dim(data)[2],length(breaks)-1)
for (i in 1:dim(data)[2]) a[i,] <- hist(data_N[,i],breaks=breaks,plot=FALSE)$counts
b          <- as.matrix(hist(data_N[,1],breaks=breaks,plot=FALSE)$mids)
minhist    <- min(which(b > 0.5))
maxhist    <- max(which(b <= 2))
int_0      <- (a[,1]-median(a[,1]))/sqrt(var(a[,1]))
quants     <- matrix(0,5,dim(a)[1])
for (i in 1:dim(a)[1]) quants[,i] <- quantile(data_N[,i],c(.1,.2,.3,.4,.5))
for (i in 1:5) quants[i,] <- (quants[i,]-mean(quants[i,]))/sqrt(var(quants[i,]))
int_1      <- apply(quants,2,max)
int_2      <- apply(quants,2,min)
jj         <- which(abs(int_2)>abs(int_1))
int_1[jj]  <- int_2[jj]
int_1      <- (int_1-median(int_1))/sqrt(var(int_1))
if (std.outliers <= 0){
   cat("\t- DEACTIVATED...\n")
   inp <- 1:length(int_0)
   out <- c()
} else {
    out        <- which( (abs(int_0) > std.outliers) | (abs(int_1) > std.outliers))
    inp        <- which( (abs(int_0) <= std.outliers) & (abs(int_1) <= std.outliers))
    if (length(out) > 0){
       data_N     <- data[,inp];
       j          <- which(apply(data[,inp],1,median)!=0)
       data_N[j,] <- data_N[j,]/t(kronecker(matrix(1,ncol(data[,inp]),1), matrix(apply(data_N[j,],1,median),1,length(j)))) 
       cat("\t- Max Dev allowed=",std.outliers,"\n",sep="")
       for (i in 1:length(out)){
          cat("\t- SAMPLE #",out[i]," (",names[out[i]],") excluded: [",int_0[out[i]],",",int_1[out[i]],"]\n",sep="")
       }
    }else {
       cat("\t- Max Dev allowed=",std.outliers,"\n",sep="")
       cat("\t- NO OUTLIERS\n")
    }
}

#################
## CORRELATION ##
#################
if (mode!=""){
  if (length(adducts)==0) adducts <- adduct.list(mode)
  if (mode=="+"){
    i <- which(adducts$labels=="[M+H]")
  } else {
    i <- which(adducts$labels=="[M-H]")
  }
  diffs <- adducts$masses-adducts$masses[i]
  diffs <- sort(abs(c(diffs[setdiff(1:length(diffs),i)],1.00335,2.00670)))
}
cat("COMPUTING CORRELATION MATRIX...\n\t")
tot   <- round((dim(data_N)[1]-1)*dim(data_N)[1]/20)
corrM <- matrix(0,tot,6)
L     <- length(inp)
## WITH M/Z FILTER
if (mode!=""){
  if (!zero.missing){
    cat("- Zeros=NotMissing\n\t")
    k   <- 0
    ind <- 1
    for(i in 1:(dim(data_N)[1]-1)) {
      for(j in (i+1):dim(data_N)[1]) {
        cc5 <- abs(rt[i]-rt[j])
        if (cc5<max.rt){
          cct <- abs(mz[j]-mz[i])
          if (any(abs(diffs-cct)<mz.tol)){
            cc3 <- cor(data_N[i,],data_N[j,])
            if (cc3>=min.corr){
              corrM[ind,] <- c(i,j,cc3,0,cc5,cct)
              ind      <- ind + 1
            }
          }
        }
        if (k %% tot == 0) cat(10*k/tot,"% ",sep="")
        k = k+1
      }
    }
    cat("\n",sep="")
  } else {
    cat("- Zeros = Missing\n\t")
    data_N[which(data_N==0)] <- NA
    k   <- 0
    ind <- 1
    for(i in 1:(dim(data_N)[1]-1)) {
      for(j in (i+1):dim(data_N)[1]) {
        cc4 <- length(which(is.na(data_N[i,])|is.na(data_N[j,])))
        if (cc4 < L-1){
          cc5 <- abs(rt[i]-rt[j])
          if (cc5<max.rt){
            cct <- abs(mz[j]-mz[i])
            if (any(abs(diffs-cct)<mz.tol)){
              cc3 <- cor(data_N[i,],data_N[j,],use="pairwise.complete.obs")
              if (cc3>=min.corr){
                corrM[ind,] <- c(i,j,cc3,100*(L-cc4)/L,cc5,cct)
                ind         <- ind + 1
                if (ind>dim(corrM)[1]) corrM <- rbind(corrM,matrix(0,tot,6))
              }
            }
          }
        }
        if (k %% tot == 0) cat(10*k/tot,"% ",sep="")
        k = k+1
      }
    }
    cat("100%\n",sep="")
  }
} else {
## WITHOUT M/Z FILTER
  if (!zero.missing){
      cat("- Zeros=NotMissing\n\t")
      k   <- 0
      ind <- 1
      for(i in 1:(dim(data_N)[1]-1)) {
         for(j in (i+1):dim(data_N)[1]) {
               cc3 <- cor(data_N[i,],data_N[j,])
               cc5 <- abs(rt[i]-rt[j])
               if ( cc3>min.corr && cc5<max.rt ){
                   corrM[ind,] <- c(i,j,cc3,0,cc5,abs(mz[i]-mz[j]))
                   ind      <- ind + 1
               }
               if (k %% tot == 0) cat(10*k/tot,"% ",sep="")
               k = k+1
         }
      }
      cat("\n",sep="")
  } else {
      cat("- Zeros = Missing\n\t")
      data_N[which(data_N==0)] <- NA
      k   <- 0
      ind <- 1
      for(i in 1:(dim(data_N)[1]-1)) {
         for(j in (i+1):dim(data_N)[1]) {
               cc4 <- length(which(is.na(data_N[i,])|is.na(data_N[j,])))
               if (cc4 < L-1){
                   cc5 <- abs(rt[i]-rt[j])
                   if (cc5<max.rt){
                       cc3 <- cor(data_N[i,],data_N[j,],use="pairwise.complete.obs")
                       if (is.na(cc3)==F){
                         if (cc3>=min.corr){
                             corrM[ind,] <- c(i,j,cc3,100*(L-cc4)/L,cc5,abs(mz[i]-mz[j]))
                             ind         <- ind + 1
                             if (ind>dim(corrM)[1]) corrM <- rbind(corrM,matrix(0,tot,6))
                         }
                       }
                   }
               }
               if (k %% tot == 0) cat(10*k/tot,"% ",sep="")
               k = k+1
         }
      }
      cat("100%\n",sep="")
  }
}
corrM <- corrM[1:(ind-1),]

##############
## FIGURES  ##
##############
if (fplot){
  par(mfrow=c(2,3))
  cols <- c("black","red","blue","yellow","azure","brown","blueviolet","cyan","magenta","orange","purple")
  ## 1
  plot(int_0[1],int_1[1],pch=20, xlim=c(min(int_0),max(int_0)),ylim=c(min(int_1),max(int_1)),col="black",type="p",cex=1.5,main="(a) Outlier scores",xlab="Zero-intensity",ylab="Quantiles")
  for (i in 2:length(int_0)){
    points(int_0[i], int_1[i], col=cols[i%%11+1], pch=20,cex=1.5)
  }
  abline(h=std.outliers)
  abline(v=std.outliers)
  abline(h=-std.outliers)
  abline(v=-std.outliers)
  grid()
  ## 2
  plot(c(.1,.2,.3,.4,.5),quants[,1],type="p",col="black",cex=1.2,main="(b) Quantiles",ylab="Standardized quantiles",xlab="Probs",ylim=c(-7,7))
  lines(c(.1,.2,.3,.4,.5), quants[,1],col="black")
  for (i in 2:dim(quants)[2]){
    lines(c(.1,.2,.3,.4,.5), quants[,i],col=cols[i%%11+1])
    points(c(.1,.2,.3,.4,.5), quants[,i],col=cols[i%%11+1])
  }
  ## 3
  plot(b, a[1,],col="black", type="l", cex = 1.2, main = "(c) Intensity histograms", ylim=c(0,max(max(a))),  xlab = "Intensity", ylab = "Counts", xlim = c(0,1.5),font=2)
  for (i in 2:dim(a)[1]){
    lines(b, a[i,],col=cols[i%%11+1])
  }
  grid()
  ## 4
  hist(corrM[,3], col=heat.colors(40)[seq(40,1,-1)], breaks=30,main="(d) Correlation Histogram",xlab="Correlation",ylab="#Feature pairs")
  ## 6
  hist(corrM[,5], col=heat.colors(40), breaks=30,main="(e) RT differences histogram",xlab="RT diff (s)",ylab="#feature pairs")
  ## 5
  v   <- c()
  mzs <- seq(0.5,80,0.1)
  for (i in mzs) v<-c(v,length(which(abs(corrM[,6]-i)<0.05)))
  i <- which(v>0)
  par(cex.lab=.1)
  temp <- getOption("warn")
  options(warn=-1)
  polar.plot(log10(1+v[i])+0.001,mzs[i]*360/80,labels=seq(0,77.5,by=2.5),label.pos=seq(0,77.5,by=2.5)*360/80,rp.type="r",main="(f) M/Z differences",lwd=2,line.col=4)
  options(warn=temp)
  par(cex.lab=1)
  par(mfrow=c(1,1))
}
scores <- list(int_0 = int_0,int_1 = int_1)
return(list(corrM = corrM, out = out, inp = inp, scores = scores))
}

data.norm <-
function(datalist, std.outliers = 3, zero.missing = TRUE, min.corr = .75, max.rt = 3, mode = "", mz.tol = 1e-3, adducts = c(), fplot = TRUE){

##########
## INIT ##
##########
datalist$names <- colnames(datalist$data[3:dim(datalist$data)[2]])
mz        <- as.numeric(as.matrix(datalist$data[,1]))
rt        <- as.numeric(as.matrix(datalist$data[,2]))
Nfeature  <- length(rt)
Nsamples  <- ncol(datalist$data)-2
data      <- as.numeric(as.matrix(datalist$data[,3:ncol(datalist$data)]))
nans      <- which(is.nan(data))
data[nans]<- 0
data      <- matrix(data,Nfeature,Nsamples)
for(i in 1:Nfeature) {
   for(j in 1:Nsamples) data[i,j] <- as.numeric(data[i,j])
}
index     <- order(mz)
mz        <- mz[index]
rt        <- rt[index]
data      <- data[index,]
cat("DATASET:\n", sep = "")
cat("","- #Features: ",Nfeature,"\n", sep = "\t")
cat("","- #Samples:  ",Nsamples,"\n", sep = "\t")
cat("","- RT limits: ",paste("[",round(min(rt),2),",",round(max(rt),2),"]"),"\n", sep = "\t")
cat("","- M/Z limits:",paste("[",round(min(mz),2),",",round(max(mz),2),"]"),"\n", sep = "\t")
##############################################
## COUNTS NORMALIZATION & OUTLIER DETECTION ##
##############################################
out    <- norm.counts(datalist$names, data, mz, rt, std.outliers, zero.missing, min.corr, max.rt, mode = mode, mz.tol = mz.tol, adducts = adducts, fplot)
data   <- data[,out$inp]
colnames(out$corrM) <- c("Index feature 1","Index feature 2","Correlation","%samples","RTdiff","M/Zdiff")
colnames(data)      <- datalist$names[out$inp]
cat("FEATURE PAIRS SELECTION RESULTS:\n", sep = "")
cat("","- MAX RT DIFFERENCE ALLOWED:",max.rt,"\n", sep = "\t")
cat("","- MIN CORRELATION ALLOWED:",min.corr,"\n", sep = "\t")
cat("","- FEATURE PAIRS SELECTED:",dim(out$corrM)[1],"\n", sep = "\t")
if (mode=="") cat("","- M/Z-DIFF PRE-FILTERING: OFF\n", sep = "\t")
if (mode!="") cat("","- M/Z-DIFF PRE-FILTERING: ON\n", sep = "\t")

return(list(data=data ,class=datalist$class, mz=mz, rt=rt, feature.set=out$corrM, outliers=out$out, scores=out$scores))
}

\name{web.report}
\alias{web.report}
\title{WEB REPORT}
\description{Generates a web report}
\usage{
astream.annotate(ftlist, results, dataset.name = "", output.dir = "web_report")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ftlist }{ list returned by \code{\link{isotope.search}}.}
  \item{results }{ matrix returned by \code{\link{adduct.search}}.}
  \item{dataset.name }{ Dataset name.}
  \item{output.dir}{ Folder that will be created for the web report.}
}
\details{
}
\value{
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{xcms.import}}, \code{\link{data.norm}}, \code{\link{isotope.search}}, \code{\link{adduct.search}}, \code{\link{plotcompound}}.}

\name{isotope.search}
\alias{isotope.search}
\title{Method for identifying Carbon isotope patterns}
\description{
Identification of Carbon isotope patterns corresponding to the Carbon-12 and the two first Carbon-13 isotope peaks from the same molecular compound.
}
\usage{
isotope.search(ftlist, mz.tol = 3e-3, min_samples = 5, max_ratio = 0.8, n_std = 5, fplot = TRUE)
}
\arguments{
  \item{ftlist }{ feature list as returned by \code{\link{data.norm}}.}
  \item{mz.tol }{ tolerance for M/Z values.}
  \item{min_samples }{ Minimum number of feature pairs matching the isotopic pattern to fit a linear regression model between m/z and intensity ratio.}
  \item{max_ratio }{ Upper intensity ratio threshold to consider a feature pair as an isotopic pattern.}
  \item{n_std }{ inclusion threeshold for the LR model. Linear regression fitting is performed iteratively until any feature pair resulting residuals exceed n_std times the residuals standar deviation.}
  \item{fplot }{ logical, if \code{'TRUE'} summary figures are plotted.}
}
\details{
\code{isotope.search} returns the same list as the introduced input argurment \code{'ftlist'}. A list of identified 
isotope patterns is added to the list.
}
\value{
  \item{isotopes }{ matrix of isotope patterns is included in the input argument \code{'ftlist'}. Each line is related to a matched isotope pattern.}
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{xcms.import}}, \code{\link{data.norm}}, \code{\link{adduct.search}}, \code{\link{printresults}}, \code{\link{plotcompound}}.}
\examples{
## Load example data
data(astream.data, package = "AStream")
## Normalize intensities, search for outliers and feature pairs selection
feat <- data.norm(input, min.corr=0.7)
## Identify Carbon isotopes
feat <- isotope.search(feat, mz.tol = 1e-2)
## Show results
feat$isotopes[1:min(15,dim(feat$isotopes)[1]),]
## Plot fitting residuals of the 13C1 isotopic patterns
plot(feat$isotopes[,7],xlab="isotopic pattern (13C1)",ylab="residuals/std(residuals))")
## Plot fitting residuals of the 13C2 isotopic patterns
plot(feat$isotopes[,8],xlab="isotopic pattern (13C2)",ylab="residuals/std(residuals))")
}

\name{AStream-package}
\alias{AStream-package}
\alias{AStream}
\docType{package}
\title{AStream: An R package for annotating LC/MS metabolomic feature data}
\description{An R package for the annotation of LC/MS metabolomic data. Identifies isotope, adduct and fragment peaks corresponding to the same molecular compound using 
intensity correlation, retention time and m/z differences between feature pairs.}
\details{
\tabular{ll}{
Package: \tab AStream\cr
Type: \tab Package\cr
Version: \tab 2.0\cr
Date: \tab 2013-12-01\cr
License: \tab GPL (>=2)\cr
LazyLoad: \tab no\cr
}
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{xcms.import}}, \code{\link{data.norm}}, \code{\link{isotope.search}}, \code{\link{adduct.search}}, \code{\link{printresults}}, \code{\link{plotcompound}}.}
\examples{
## Analysis of metabolomic LC/MS data from 20 human serum samples

## Loading example data: This command loads an example dataset on 
## a list containing two objects, \code{data} and \code{class}.
data(astream.data,package="AStream")

## Normalize intensities, search for outliers and feature pairs selection. 
## A feature pair is selected if the correlation between the two features exceeds 0.7 and
## their retetion time difference is less than the default (3).
feat <- data.norm(input, min.corr = 0.7)

## Extra pre-filtering based on expected m/z differences can be performed using extra arguments.
## In this example feature pairs must also fulfill an expected m/z difference depending on the
## related isotopes and adducts differences. \code{adducts = c()} uses the default list of isotopic
## and adduct patterns for positive ionization mode \code{mode = "+"}. \code{mz.tol} defines a 
## tolerance window for m/z measurements.
feat <- data.norm(input, min.corr = 0.7, mode = "+", mz.tol = 1e-2, adducts = c())

## Identifies Carbon isotopes
feat <- isotope.search(feat, mz.tol = 1e-2)

## Search for adducts
res   <- adduct.search(feat, mz.tol = 1e-2, onlyIsotopes = FALSE, mode = "+")

## Format and export results: \code{range} defines the window aroung the feature m/z value where HMDB compounds
## are searched. In this example, HMDB search is restricted to blood and urine compounds. \code{nfg_min = 1} rules out
## features with any related feature meeting an isotopic or adduct pattern.
data  <- astream.annotate(feat, res, range = 1e-2, mode = "+", nfg_min = 1, output = "results.txt", location = c("blood","urine"))

## Create web report
web.report(feat,res,"results.txt",dataset.name="AStream example", output.dir = "web_report")

## Check compound profiles along all samples from any particular identified compound of interest
plotcompound(1338, feat, res)
plotcompound(158, feat, res)
plotcompound(285, feat, res)
plotcompound(733, feat, res)
plotcompound(818, feat, res)
}

\name{compute.count.stats}
\alias{compute.count.stats}
\title{internal function}
\description{internal function}
\usage{
compute.count.stats(features)
}
\arguments{
  \item{features}{NA}
}
\details{NA}
\value{NA}

\name{adduct.search}
\alias{adduct.search}
\title{Method for identifying adduct patterns}
\description{Identification of features corresponding to different adducts of the same molecular compound.}
\usage{adduct.search(ftlist, mz.tol = 3e-3, adducts = 0, mode = "+", onlyIsotopes = TRUE, fplot = TRUE)}
\arguments{
  \item{ftlist }{ feature list as returned by \code{\link{isotope.search}}.}
  \item{mz.tol }{ tolerance for M/Z values.}
  \item{adducts }{ adduct list (see details).}
  \item{onlyIsotopes }{If onlyIsotopes=1, the adduct search will only take into account features that have been previously 
associated to an isotope pattern.}
  \item{fplot }{ logical, if \code{'TRUE'} summary figures are plotted.}
}
\details{
If \code{adducts} is equal to 0 a default table of adducts will be used using the ionization mode specified by \code{mode}. If the user wants to provide its own 
adduct list it must be added through the \code{adducts} argument. \code{adducts} must be a list() object with two vectors named \code{labels} 
(i.e. \code{c("[M+H]", "[M+2H]", "[M+3H]", "[M+NH4]")}) and \code{masses}(i.e. \code{c(1.00728, 2.0145, 3.0218, 18.0338)}). [M+H] and [M-H] are respectively mandatory for positive 
and negative ionization modes.
}
\value{
A matrix containing the final results. Each row corresponds to a compound and the indexes of all the features 
related to this compound (isotopes, adducts, fragments...) are provided.
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{data.norm}}, \code{\link{isotope.search}}, \code{\link{printresults}}, \code{\link{plotcompound}}.}
\examples{
## Load example data
data(astream.data,package="AStream")

## Normalize intensities, search for outliers and feature pairs selection
feat <- data.norm(input)

## Identify Carbon isotopes
feat <- isotope.search(feat)

## Search for adducts
results <- adduct.search(feat)
## Show some results
results[1:min(30,dim(results)[1]),]

## Adduct table provided by the user as a 'data.frame'
table <- list(masses=c(1.007276, 18.033823,22.989218,38.963158,68.99472),
                          labels = c("[M+H]","[M+NH4]","[M+Na]","[M+K]","[M+NaHCOOH]"))
results <- adduct.search(feat, adducts = table)
}

\name{hmdb}
\alias{hmdb}
\docType{data}
\title{
Metabolites imported from the HMDB 
}
\description{
List of metabolites imported from the Human Metabolome Database.
}
\usage{data(hmdb)}
\format{
  A data frame with 41488 observations on the following 5 variables.
  \describe{
    \item{\code{accession}}{accession names}
    \item{\code{mass}}{monoisotopic masses}
    \item{\code{name}}{compound names}
    \item{\code{biofluid}}{biofluid locations}
    \item{\code{tissue}}{tissue locations}
  }
}
\details{
%%  ~~ If necessary, more details than the __description__ above ~~
}
\source{
http://www.hmdb.ca
}

\name{astream.annotate}
\alias{astream.annotate}
\title{FORMATTING AND EXPORTING RESULTS}
\description{Function for formatting and exporting the obtained results}
\usage{
astream.annotate(ftlist, results, range = 0.01, mode = "+", location = c(), nfg_min = 0, output = "")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ftlist }{ list returned by \code{\link{isotope.search}}.}
  \item{results }{ matrix returned by \code{\link{adduct.search}}.}
  \item{range }{ m/z tolerance around the identified features m/z for identifying compounds within the HMDB database.}
  \item{mode}{ ionization mode ("+" or "-").}
  \item{location}{ Allowed biofluid and tissue metabolite locations.}
  \item{nfg_min}{ Minimum number of related features (isotopic/adduct patterns) to export a given feature.}
  \item{output }{ filename where results will be saved.}
}
\details{
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
  \item{id }{ Feature ID.}
  \item{MZ }{ Feature m/z value.}
  \item{MassSubmitted }{ Expected feature monoisotopic mass (i.e. MZ-H in positive ionization mode).}
  \item{RT }{ Feature retention time value.}
  \item{FoldChange }{ Intensity fold change between groups.}
  \item{N1 }{ Number of samples (group 1).}
  \item{N2 }{ Number of samples (group 2).}
  \item{P-value }{ P-Value.}
  \item{Metlin }{ Link to Metlin.}
  \item{REF.NFG }{ Number of related features (isotopic/adduct patterns).}
  \item{REF.13C#1-isotope }{ Related 13C1 isotopic feature.}
  \item{REF.13C#2-isotope }{ Related 13C2 isotopic feature.}
  \item{REF.Adducts }{ Related adduct features.}
  \item{NOTREF.NFG }{ Number of times the feature has been related to another feature.}
  \item{NOTREF.LABELS }{ Related isotopic/adduct features.}
  \item{HMDB.N }{ Number of HMDB hits.}
  \item{HMDB.MATCHS }{ HMDB hits.}
}
\references{
  http://www.hmdb.ca
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{xcms.import}}, \code{\link{data.norm}}, \code{\link{isotope.search}}, \code{\link{adduct.search}}, \code{\link{plotcompound}}.}
\examples{
## Load example data
data(astream.data, package="AStream")

## Normalize intensities, search for outliers and feature pairs selection
feat <- data.norm(input, min.corr = 0.7, mode = "+", mz.tol = 1e-2, adducts = c())

## Identify Carbon isotopes
feat <- isotope.search(feat, mz.tol = 1e-2)

## Search for adducts
res   <- adduct.search(feat, mz.tol = 1e-2, onlyIsotopes = FALSE, mode = "+")

## Save results to file
data  <- astream.annotate(feat, res, range = 1e-2, mode = "+", nfg = 1, output = "results.txt", location = c("blood","urine"))
}

\name{data.norm}
\alias{data.norm}
\title{
Perform intensity normalization, outlier detection and feature pairs selection
}
\description{
Intensity data from multiple samples is used to normalize each feature intensity. The resulting intensities 
are then used to compute the sample outlier scores based on the lower quantiles and the total number of features 
with zero intensity. Finally, the correlation values of each feature pair is computed and only those pairs 
that pass the defined filter thresholds (i.e. low retention time difference, m/z difference and/or high correlation) are included for further analysis.
}
\usage{
data.norm(datalist, std.outliers = 3, zero.missing = TRUE, min.corr = .75, max.rt = 3, mode = "", mz.tol = 1e-3, adducts = c(), fplot = TRUE)
}
\arguments{
  \item{datalist }{ LC-MS feature data set either created by the user or loaded from an XCMS object (see \code{xcms.import}).}
  \item{std.outliers }{ samples having a standardized outlier score over this value are excluded.}
  \item{zero.missing }{ logical, intensity equal to 0 is considered as a missing value.}
  \item{min.corr }{ correlation threshold. Feature pairs with an intensity correlation below this value are excluded.}
  \item{max.rt }{ retention time difference threshold. Feature pairs with a retention time difference over this value are excluded.}
  \item{mode }{ ionization mode. Three accepted values: "", "+" and "-". "+" and "-" turn on m/z filtering after correlation computation to check if m/z differeces between feature pairs match the expected differences for isotopic or adduct patterns (\code{mz.tol} must be provided).}
  \item{mz.tol }{ tolerance for M/Z values. It must be provided when mode="+" or mode="-".}
  \item{adducts }{ user provided adduct list.}
  \item{fplot }{ logical, if \code{'TRUE'} summary figures are plotted.}
}
\details{
\code{datalist} should be imported from a XCMS object using \code{\link{xcms.import}}. It can also be provided by the user 
creating a list with two arguments: (1) \code{data}, a data.frame where rows correspond to features and the first two columns 
correspond to the m/z and retention time values, respectively. The remaining columns correspond to the feature intensities for 
each of the analyzed samples, with sample names in their respective headers and, (2) \code{class}, a vector containing the group 
label of each sample. The values of the \code{min.corr} and \code{min.rt} arguments determine the inclusion/exclusion thresholds for feature pairs. Only feature pairs 
having an intensity correlation value over \code{min.corr} and a retention time difference below \code{max.rt} will be returned for further analysis. When \code{mode} is turned on 
(mode="+" or mode="-") feature pair m/z differences must match the expected differences for any isotopic or adduct pattern. If the user wants to provide its own 
adduct list it must be added through the \code{adducts} argument. \code{adducts} must be a list() object with two vectors named \code{labels} 
(i.e. \code{c("[M+H]", "[M+2H]", "[M+3H]", "[M+NH4]")}) and \code{masses}(i.e. \code{c(1.00728, 2.0145, 3.0218, 18.0338)}). [M+H] and [M-H] are respectively mandatory for positive 
and negative ionization modes.
}
\value{
A list containing the following names:
  \item{data }{ intensity matrix where rows correspond to features and columns to included samples.}
  \item{class }{ sample phenotypes.}
  \item{mz }{ m/z values of each feature.}
  \item{rt }{ retention time values of each feature.}
  \item{feature.set }{ a five-column matrix with the data corresponding to the feature pairs that passed the filters.}
  \item{outliers }{ indexes of the excluded samples.}
  \item{scores }{ outlier scores of each sample.}
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{xcms.import}}, \code{\link{isotope.search}}, \code{\link{adduct.search}}, \code{\link{printresults}}, \code{\link{plotcompound}}.}
\examples{
## Load example data
data(astream.data,package="AStream")
## data.norm using default parameters
feat <- data.norm(input)
## Shows selected feature pairs
feat$feature.set[1:min(15,dim(feat$feature.set)[1]), ]
# data.norm changing the default parameters and without outlier detection
feat <- data.norm(input, std.outliers = -1, min.corr = 0.90, max.rt = 2)
# data.norm using m/z differences pre-filtering and the default adduct list
feat <- data.norm(input, min.corr = 0.7, mode = "+", mz.tol = 1e-2, adducts = c())
}

\name{xcms.import}
\alias{xcms.import}
\title{
Import required data from an XCMS object
}
\description{
Imports data required for AStream analysis directly from a XCMS object.
}
\usage{
xcms.import(object)
}
\arguments{
  \item{object }{ XCMS object.}
}
\value{
A list containing the following names:
  \item{data }{ data.frame where rows correspond to features and the first two columns correspond to the m/z  and retention time values, respectively. The remaining columns correspond to the feature intensities for each of the analyzed samples.}
  \item{class }{ sample phenotypes.}
}
\references{
  Smith C.A., Want E.J., O'Maille G., Siuzdak G. "XCMS: Processing mass spectrometry data for metabolite profiling using nonlinear peak alignment, matching and identification."
  Analytical Chemistry 2006
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{data.norm}}, \code{\link{isotope.search}}, \code{\link{adduct.search}}, \code{\link{printresults}}.}
\examples{
## Perform data pre-processing with XCMS on faahKO dataset
library(xcms)
library(faahKO)
cdfpath <- system.file("cdf", package = "faahKO")
cdffiles <- list.files(cdfpath, recursive = TRUE, full.names = TRUE)
xset <- xcmsSet(cdffiles, snthresh = 3)
xset <- group(xset)
xset <- retcor(xset, family = "s", plottype = "none")
xset <- group(xset, bw = 10)
xset <- fillPeaks(xset)
## Import data directly from XCMS object
input <- xcms.import(xset)
}

\name{adduct.list}
\alias{adduct.list}
\title{Default adduct list}
\description{Provides a default adducts list based on the selected ionization mode.}
\usage{
adduct.list(mode = "+")
}
\arguments{
  \item{mode }{ ionization mode.}
}
\details{
}
\value{
  \item{labels }{ adduct labels.}
  \item{masses }{ adduct masses.}
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}

\name{norm.counts}
\alias{norm.counts}
\title{
Intensity normalization, outlier detection and feature selection
}
\description{
This is an internal function called by \code{\link{data.norm}}.
}
\usage{
norm.counts(names, data, mz, rt, std.outliers, zero.missing, min.corr, max.rt, mode = "", mz.tol = 1e-3, adducts = c(), fplot)
}
\arguments{
  \item{names }{ sample names.}
  \item{data }{ intensity matrix where rows correspond to features and columns to samples.}
  \item{mz }{ m/z values of each feature.}
  \item{rt }{ retention time values of each feature.}
  \item{std.outliers }{s amples having an outlier score over this value are excluded.}
  \item{zero.missing}{ logical, intensity equal to 0 is considered as a missing value.}
  \item{min.corr }{ correlation threshold. Feature pairs with an intensity correlation below this value are excluded.}
  \item{max.rt }{ retention time difference threshold. Feature pairs with a retention time difference over this value are excluded.}
  \item{mode }{ ionization mode. Three accepted values: "", "+" and "-". "+" and "-" turn on m/z filtering after correlation computation to check if m/z differeces between feature pairs match the expected differences for isotopic or adduct patterns (\code{mz.tol} must be provided).}
  \item{mz.tol }{ tolerance for M/Z values. It must be provided when mode="+" or mode="-".}
  \item{adducts }{ user provided adduct list.}
  \item{fplot }{ logical, if \code{TRUE} plots summary figures.}
}
\value{
  \item{corrM }{ a five-column matrix with the data corresponding to the feature pairs that passed the filters.}
  \item{out }{ indexes of the excluded samples.}
  \item{inp }{ indexes of the included samples.}
  \item{scores }{outlier scores of each sample.}
}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{data.norm}}.}

\name{pvalcc}
\alias{pvalcc}
\title{internal}
\description{internal}
\usage{
pvalcc(X, classlabel, teststat)
}
\arguments{
  \item{X}{X}
  \item{classlabel}{classlabel}
  \item{teststat}{teststat}
}
\details{internal}
\value{internal}

\name{plotcompound}
\alias{plotcompound}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Plot feature and related isotopic/adduct features.}
\description{Plot a feature and related isotopic/adduct features}
\usage{
plotcompound(num, ftlist, results)
}
\arguments{
  \item{num}{feature id to be plotted}
  \item{ftlist}{AStream isotope.search() output}
  \item{results}{Astream adduct.search() output}
}
\details{Plot a feature and related isotopic/adduct features}
\value{A plot.}
\author{A.Alonso, et al. Grup de Recerca de Reumatologia 2010, bioinformatics@urr.cat.}
\seealso{\code{\link{data.norm}}, \code{\link{isotope.search}}, \code{\link{printresults}}, \code{\link{plotcompound}}.}
